import socket as sock
from threading import Thread
import os
import struct
import json

from processing.text_handler import TextHandler


class ServerSocket(Thread):

    def __init__(self, main, port=25565):
        Thread.__init__(self)
        self.mainThread = main
        self.setDaemon(True) # ne bloque pas l'arret du programme
        self.socket = sock.socket(sock.AF_INET, sock.SOCK_STREAM)
        self.socket.bind(('0.0.0.0', port))
        print "Serveur ouvert sur le port", port

        self.shouldStop = False

    def run(self):
        self.socket.listen(1)
        conn, addr = self.socket.accept() # attend la connexion de l'interface

        while not self.shouldStop:
            json_string = conn.recv(2048)
             # { "action": <action>, "params": {}}
            try:
                j = json.loads(json_string)
                if j["action"] == "stop":
                    self.socket.close()
                    os._exit(0)
                elif j["action"] == "test":
                    print("Test -> ", j["params"]["message"])
                elif j["action"] == "settext":
                    text = j["params"]["text"]
                    print("Setting text to ", text)
                    for mode in self.mainThread.processing.modes:
                        if isinstance(mode, TextHandler):
                            mode.setText(text)
                elif j["action"] == "forceDMXState":
                    self.mainThread.setDMXControl(j["params"]["state"])
                else:
                    print("Unknown action ", j.action)
            except (ValueError, KeyError) as msg :
                print(msg)
                continue
        self.socket.close()

    def stop(self):
        self.shouldStop = True
