from __future__ import division
import serial
from threading import Thread
import struct
import time

class DMX(Thread):
        CHAN_TO_POS = []

	def __init__(self, led_matrix, main, serial_port="/dev/ttyUSB0", serial_rate=9600):
		Thread.__init__(self)
		
		self.s = serial.Serial()
		self.s.port = serial_port
		self.s.baudrate = serial_rate

		self.led_matrix = led_matrix
		self.main = main

		self.active = False

		self.cur_led_colour = [0, 0, 0]

                for i in range(self.led_matrix.height):
                    for j in range(self.led_matrix.width):
                        self.CHAN_TO_POS.append([j,i])
                #self.main.setDMXControl(True)
	def run(self):
		try: 
			self.s.open()
		except Exception, e:
			print("Error opening DMX serial port : " + str(e))

		if self.s.isOpen():
			self.s.flushInput()
			while True:
				self.dmx_read()
		else:
			print("Error, the DMX serial port is not open even though it should be")

	def dmx_read(self):
                #time.sleep(1)
                try:
        	    line = self.s.read_until("\n")
		    (channel, data) = line.split(":")
                    if len(channel) == 0 or len(data) == 0:
                        return
                    channel = int(channel.strip())
                    data = int(data.strip())
                except Exception as e:
                    print(str(e))
                    return

		if channel == 1 : # Special toggle channel
                        #print("Toggle: ", data)
                        #return
			if data < 10 and self.active:
				self.active = False
				self.main.setDMXControl(False)
                        elif data > 10 and not self.active:
				self.active = True
				self.main.setDMXControl(True)
                elif channel == 2: # Special brightness channel
                        #print("Brightness update: ", data)
			self.led_matrix.setBrightness(data)
		else: # The 240 remaining channels
                        #print("Channel update: ", channel, " with ", data)
			if self.active:
				index = (channel - 3) // 3
                                widthPos = index % 10
                                heightPos = index // 10
                                led = self.led_matrix.getLED(*self.CHAN_TO_POS[index])
				#print("LED colour is ", led.colour)
                                colour_pos = (channel - 3) % 3
                                led.setColourRVBIndex(colour_pos, data/255)
				#self.cur_led_colour[colour_pos] = int(data)
				#if colour_pos == 2:
				#	led.setColourRVBIndex(*self.cur_led_colour)
				#	led.setBrightness(4)
				#	self.cur_led_colour = [0, 0, 0]


